#include <bits/stdc++.h>

using namespace std;

struct par {
    int l;
    int r;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, e;
	cin >> n;
    vector <int> m, v;
    vector <par> ans;
    m.resize(n);
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> m[i];
        v[i] = m[i];
    }
    sort(v.begin(), v.end());
    e = 0;
    par p;
    for (int i = 0; i < n - 1; i++) {
        if (m[i] == v[i]) {
            continue;
        }
        for (int j = i + 1; j < n; j++) {
            if (v[i] == m[j]) {
                for (int k = i; k < (i + j) / 2; k++) {
                    swap(m[k], m[j - k + i]);
                }
                p.l = i;
                p.r = j;
                ans.push_back(p);
            }
        }
    }
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].l + 1 << " " << ans[i].r + 1 << "\n";
    }
    return 0;
}
